"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStableEffect = void 0;
var react_1 = require("react");
// Use effect prior art comes from https://github.com/kentcdodds/use-deep-compare-effect/blob/master/src/index.ts
var useEqMemoize = function (value, eq) {
    var ref = react_1.useRef();
    var signalRef = react_1.useRef(0);
    if (ref.current == null) {
        ref.current = value;
    }
    if (!eq.equals(value, ref.current)) {
        ref.current = value;
        signalRef.current += 1;
    }
    return [signalRef.current];
};
var useStableEffect = function (callback, dependencies, eq) {
    return react_1.useEffect(callback, useEqMemoize(dependencies, eq));
};
exports.useStableEffect = useStableEffect;
//# sourceMappingURL=effect.js.map